fl

hex

{
Wii nunchuk driver for PropForth
     Wii nunchuk   Propeller
     clk            P28   0x1c
     dat            P29   0x1d
Diagram below is showing the pinout looking into the connector (which plugs into the Wii Remote)
 _______ 
| 1 2 3 |
|       |
| 6 5 4 |
|_-----_|          Peopeller

1 - SDA  --------- P29
2 - 
3 - VCC  --------- 3.3V
4 - SCL  --------- P28
5 - 
6 - GND  --------- GND

Cutted connecter.   2012/8/8
VCC(Red)    --------- 3.3V
GND (White) --------- GND
SDA(Green)  --------- P29
SCL(Yellow) --------- P28

    PropForth5.2  
    12/10/2012 10:30:37
    
PropForth4.6's WORDs are used to rename, because PropForth5.2 can't get datas from Wii-nunchaku.
}

: _PF4.6eeread
	_sdai 0 8 0
	do
		1 lshift _sclh _sda? _scll
		if
			1 or 
		then
	loop
	swap
	if
		_sdah
	else
		_sdal
	then
	_sdao _sclh _scll _sdal
;



: _PF4.6eewrite
	80 8 0
	do
		2dup and
		if
			_sdah
		else
			_sdal
		then 
		_sclh _scll 1 rshift
	loop
	2drop
	 _sdai _sclh _sda? _scll _sdal _sdao
;

variable sx
variable sy
wvariable ax
wvariable ay
variable az
wvariable cb
wvariable z
d127 wconstant cal_joy_x
d135 wconstant cal_joy_y
d525 wconstant cal_z

d40000000 constant 500msec

\ ( c1 -- )  write 1-byte
: _slave_w
	_PF4.6eewrite
	if
		8007 ERR
	then
;

\ ( n1 n2 -- )   I2C Start    n1:register-address  n2:slave-address 
: _slave_s
	_eestart
	_slave_w               \ slave address 
	_slave_w               \ register adress 
;                                      

\ ( n1 -- )  only Data Read   n1:slave-address 
: _slave_sr 
	_eestart
	1+ _slave_w            \ slave address + rd[1] 
;

\ (n1 n2 n3 -- )     n1:i2cdata n2:register adress n3:slave address 
: nunchuck_location _slave_s _slave_w _eestop ;

: init_nunchuck
55 F0 A4 nunchuck_location  
;

: readNunchaku 
0 FB A4 nunchuck_location
_eestart A4 _slave_w 0 _slave_w _eestop
_eestart A4 _slave_sr 5 0 do 0 _PF4.6eeread loop -1 _PF4.6eeread _eestop ;

: get_value
dup 1 and z W!      \ z-button
dup 2 and cb W!      \ c-button
2 rshift dup 3 and ax W!
2 rshift dup 3 and ay W!
2 rshift 3 and az L!
2 lshift az L@ + cal_z - az L! 
2 lshift ay W+!
2 lshift ax W+!

cal_joy_y - sy L!
cal_joy_x - sx L!
;

: test_Nunchaku 
init_nunchuck
cnt COG@ 500msec +
begin     
     readNunchaku
     get_value
     ." SX:" sx L@ . ." SY:" sy L@ .  ." AX:" ax W@ . ." AY:" ay W@ . ." AZ:" az L@ . ." c:" cb W@ . ." z:" z W@ . cr                     
     500msec waitcnt
fkey? swap drop until     
drop
;

decimal
